#include <Adafruit_MLX90614.h>
#include <Servo.h>  
Servo myservo1;
Adafruit_MLX90614 mlx = Adafruit_MLX90614();
int pocetCyklu = 0;
const int d9 =9;
// číslo pinu připojeného analogového vstupu
const int analogIn = A0;
// konstanta pro přepočet naměřeného napětí na proud
const int konstanta = 185;
// proměnná pro nastavení offsetu, polovina Vcc
const int offset = 2500;
int pos;


double tempAmbient = 0;
double tempObject = 0;
double current = 0;

void setup() {
  pinMode(analogIn, INPUT);
  myservo1.attach(d9); 
  Serial.begin(9600);
  while (!Serial);

  if (!mlx.begin()) {
    Serial.println("Error connecting to MLX sensor. Check wiring.");
    while (1);
  };
  
  delay(5000);//zpoždění aby se hned nespustil program
}
void merProud() {
  int analog = 0;
  double napeti = 0;
  double proud = 0;
  double soucet = 0;
  // provedení stovky měření pro ustálení výsledku
  for (int i = 0; i < 100; i++) {
    // načtení hodnoty analogového vstupu
    analog = analogRead(analogIn);
    // přepočet napětí na proud dle informací od výrobce
    napeti = (analog * 5000.0) / 1023.0;
    proud = (napeti - offset) / konstanta;
    // uložení výsledku pro následné zprůměrování
    soucet += proud;
    delay(0.7);
  }
  // výpočet průměru ze stovky měření
  proud = (soucet / 100);
  // výpis výsledku na 3 desetinná místa
  current = proud;
}
void merTemp() {
  tempAmbient = mlx.readAmbientTempC();
  tempObject = mlx.readObjectTempC();
}
void vypis() {
  /*Serial.print("Proud: ");
  Serial.print(current,3);
  Serial.print(" A  ;");
  Serial.print("Ambient = "); Serial.print(tempAmbient);
	Serial.print("  ;*C\tObject = "); Serial.print(tempObject); Serial.println("*C;");*/
  Serial.print(current, 3);
  Serial.print(";");
  Serial.print(tempAmbient);
  Serial.print(";");
  Serial.print(tempObject);
  Serial.println();
}

void loop() {
  Serial.println("počet cyklu: ");
  Serial.print(pocetCyklu);
  Serial.println("Zvednutí nahoru");
  
  for (pos = 10; pos <= 110; pos += 1) {  
    myservo1.write(pos); 
    merProud();
    merTemp();
    vypis();
    delay(50);                       
  }
  
  Serial.println("Zvednutí dolu");
  
  for (pos = 110; pos >= 10; pos -= 1) {  
    myservo1.write(pos);  
    merProud();
    merTemp();
    vypis();
    delay(50);                       
  }
  
  pocetCyklu++;

  Serial.println();
  
  if (pocetCyklu == 11) {
    while (true) {
      pocetCyklu++;
    }
  }
}
